利用 Golang 中的 Recover 处理错误

TimLiuDream · · 685 次点击 · 开始浏览    置顶

> 关注公众号【爱发白日梦的后端】分享技术干货、读书笔记、开源项目、实战经验、高效开发工具等,您的关注将是我的更新动力! Golang 中的 `recover` 是一个鲜为人知但非常有趣和强大的功能。让我们看看它是如何工作的,以及在 [Outreach.io](http://outreach.io/) 中如何利用它来处理 Kubernetes 中的错误。 Panic/Defer/Recover 基本上是 Golang 中对于其他编程语言中 throw/finally/catch 概念的替代品。它们有一些共同之处,但在一些重要细节上有所不同。 ## Defer 要充分理解 `recover`,我们首先需要谈论 `defer` 语句。`defer` 关键字前置于函数调用之前,使得该调用在当前函数返回之前执行。当我们在一个函数中使用多个 `defer` 语句时,它们按照后进先出的顺序执行,这使得创建清理逻辑变得非常容易,如下例所示: ```go package main import ( "context" "database/sql" "fmt" ) func readRecords(ctx context.Context) error { db, err := sql.Open("sqlite3", "file:test.db?cache=shared&mode=memory") if err != nil { return err } defer db.Close() // 这个函数调用将在 readRecords 函数返回时第三个执行 conn, err := db.Conn(ctx) if err != nil { return err } defer conn.Close() // 这个函数调用将在第二个执行 rows, err := conn.QueryContext(ctx, "SELECT id FROM users") if err != nil { return err } defer rows.Close() // 这个函数调用将在第一个执行 for rows.Next() { var id int64 if err := rows.Scan(&id); err != nil { return err } fmt.Println("ID:", id) } return nil } func main() { readRecords(context.Background()) } ``` ## Panic 我们需要谈论的第二个主题是 `panic`,它是一个导致当前 goroutine 进入 panic 模式的函数。当前函数中的正常执行流程被停止,仅执行 `defer` 语句,然后对调用者函数执行相同的操作,因此一直冒泡到堆栈的顶部(main 函数),然后使程序崩溃。`panic` 可以直接调用(传递一个值作为参数),也可以由运行时错误引起。例如,由于空指针解引用: ```go package main import "fmt" func main() { var x *string fmt.Println(*x) } // panic: runtime error: invalid memory address or nil pointer dereference ``` ## Recover `recover` 是一个内建函数,它使我们有可能在发生 panic 时重新获得控制。它仅在被调用的延迟函数中产生效果。在延迟函数之外调用时,它总是返回 `nil`。如果我们处于 panic 模式,调用 `recover` 会返回传递给 `panic` 函数的值。基本示例: ```go package main import "fmt" func main() { defer func() { if r := recover(); r != nil { fmt.Printf("Recovered: %v\\n", r) } }() panic("spam, egg, sausage, and spam") } // Recovered: spam, egg, sausage, and spam ``` 我们可以以同样的方式从运行时错误中恢复: ```go package main import "fmt" func main() { defer func() { if r := recover(); r != nil { fmt.Printf("Recovered: %v\\n", r) } }() var x *string fmt.Println(*x) } // Recovered: runtime error: invalid memory address or nil pointer dereference ``` 在这种情况下,`recover` 返回的值的类型是错误(更准确地说是 `runtime.errorString`)。 有一个限制:我们不能直接从 `recover` 块中返回值,因为在 `recover` 块中的 `return` 语句仅从延迟函数中返回,而不是从周围的函数中返回: ```go package main import "fmt" func foo() int { defer func() { if r := recover(); r != nil { fmt.Printf("Recovered: %v\\n", r) return 1 // "too many return values" 因为我们仅从匿名函数返回 } }() panic("spam, egg, sausage, and spam") } func main() { x := foo() fmt.Println(x) } ``` 如果我们想要更改函数返回的值,我们需要使用命名返回值: ```go package main import "fmt" func foo() (ret int) { defer func() { if r := recover(); r != nil { fmt.Printf("Recovered: %v\\n", r) ret = 1 } }() panic("spam, egg, sausage, and spam") } func main() { x := foo() fmt.Println("value:", x) } // Recovered: spam, egg, sausage, and spam // value: 1 ``` 一个更实际的例子,将 panic 转换为普通错误的转换可能如下所示: ```go package main import ( "fmt" "github.com/google/uuid" ) // processInput 尝试将输入字符串转换为 uuid.UUID // 它将 panic 转换为错误 func processInput(input string) (u uuid.UUID, err error) { defer func() { if r := recover(); r != nil { err = fmt.Errorf("panic: %v", r) } }() // 一些可能引发 panic 的逻辑(也可以是第三方逻辑),例如: u = uuid.MustParse(input) return u, nil } func main() { u, err := processInput("xxx") if err != nil { fmt.Println(err) } fmt.Println(u) } // panic: uuid: Parse(xxx): invalid UUID length: 3 // 00000000-0000-0000-0000-000000000000 ``` 现在让我们尝试一些稍微 复杂的东西。假设我们在 Kubernetes 中运行,并且我们想要编写一个通用的 `recover` 函数,处理所有未捕获的 panic 和运行时错误,并收集它们的堆栈跟踪,以便我们可以以结构化的方式记录它们(例如,以 JSON 格式)。 ```go package main import ( "fmt" "log" "os" "github.com/pkg/errors" ) func foo() string { var s *string return *s } func handlePanic(r interface{}) error { var errWithStack error if err, ok := r.(error); ok { errWithStack = errors.WithStack(err) } else { errWithStack = errors.Errorf("%+v", r) } return errWithStack } func main() { logger := log.New(os.Stdout, "", 0) defer func() { if r := recover(); r != nil { err := handlePanic(r) logger.Println( "panic occurred", "msg", err.Error(), "stack", fmt.Sprintf("%+v", err), ) } }() fmt.Println(foo()) } // 输出: // panic occurred msg: runtime error: invalid memory address or nil pointer dereference // stack: runtime error: invalid memory address or nil pointer dereference // main.handlePanic // /tmp/sandbox239055659/prog.go:19 // main.main.func1... ``` 以上就是今天的内容!`recover` 函数并不是 Golang 开发者的日常必备工具,但正如你所看到的,它在某些情况下非常有用。

有疑问加站长微信联系(非本文作者)

入群交流(和以上内容无关):加入Go大咖交流群,或添加微信:liuxiaoyan-s 备注:入群;或加QQ群:692541889

685 次点击  
加入收藏 微博
添加一条新回复 (您需要 登录 后才能回复 没有账号 ?)
  • 请尽量让自己的回复能够对别人有帮助
  • 支持 Markdown 格式, **粗体**、~~删除线~~、`单行代码`
  • 支持 @ 本站用户;支持表情(输入 : 提示),见 Emoji cheat sheet
  • 图片支持拖拽、截图粘贴等方式上传